Subject: 24.5; emacs hangs when X-server connection goes away

From: [email-masked]
Date: Tue, 21 Jan 2020 13:06:44 -0500

I start emacs (with or without --daemon) on my desktop, and then I open
frames with emacsclient -nw, or emacsclient -c.  When I start a frame (-c) do
so via a forwarded SSH connection (from my laptop), it works great.
When I close the ssh connection (having closed any open frames), then the
emacs process hangs; sometimes it crashes.  The hang I can reproduce easily.
{Obviously, also occurs if the SSH disconnects unexpectedly}

I notice that the SSH thinks that the X-connection is still open and it will
not exit on it's own.  This is the case even if I've closed all frames.

I can attempt this again from emacs -Q, but I have to close the emacs I'm
writing this in first so that I can start the server.

Other frames/windows are hung, I have to kill the process. (Not -9).  
I can kill -SOMETHING and/or attach GDB if that is useful.

In GNU Emacs 24.5.1 (x86_64-pc-linux-gnu, GTK+ Version 3.22.11)
 of 2017-09-12 on hullmann, modified by Debian
System Description:	Devuan GNU/Linux 2.1 (ascii)

Configured using:
 `configure --build x86_64-linux-gnu --prefix=/usr --sharedstatedir=/var/lib
 --libexecdir=/usr/lib --localstatedir=/var/lib --infodir=/usr/share/info
 --mandir=/usr/share/man --with-pop=yes
 --enable-locallisppath=/etc/emacs24:/etc/emacs:/usr/local/share/emacs/24.5/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/24.5/site-lisp:/usr/share/emacs/site-lisp
 --without-gnutls --build x86_64-linux-gnu --prefix=/usr
 --sharedstatedir=/var/lib --libexecdir=/usr/lib --localstatedir=/var/lib
 --infodir=/usr/share/info --mandir=/usr/share/man --with-pop=yes
 --enable-locallisppath=/etc/emacs24:/etc/emacs:/usr/local/share/emacs/24.5/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/24.5/site-lisp:/usr/share/emacs/site-lisp
 --without-gnutls --with-x=yes --with-x-toolkit=gtk3
 --with-toolkit-scroll-bars 'CFLAGS=-g -O2
 -fdebug-prefix-map=/build/emacs24-24.5+1=. -fstack-protector-strong -Wformat
 -Werror=format-security -Wall -fno-PIE' 'CPPFLAGS=-Wdate-time
 -D_FORTIFY_SOURCE=2' 'LDFLAGS=-Wl,-z,relro -no-pie''

Important settings:
  value of $LC_ALL: en_CA.UTF-8
  value of $LC_CTYPE: en_CA.UTF-8
  value of $LC_TIME: en_DK
  value of $LANG: en_CA.UTF-8
  locale-coding-system: utf-8-unix

Major mode: MH-Folder

Minor modes in effect:
  hl-line-mode: t
  dired-omit-mode: t
  tooltip-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com'...failed
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com --protocols ssl3'...failed
Opening TLS connection to `c5.patreon.com'...failed
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com'...failed
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com --protocols ssl3'...failed
Opening TLS connection to `c5.patreon.com'...failed
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com'...failed
Opening TLS connection with `gnutls-cli --x509cafile /etc/ssl/certs/ca-certificates.crt -p 443 c5.patreon.com --protocols ssl3'...failed
Opening TLS connection to `c5.patreon.com'...failed
Processing deletes and refiles for +inbox...done

Load-path shadows:
/sandel/src/bbdb/lisp/bbdb-ispell hides /sandel/share/emacs/site-lisp/bbdb-ispell
/sandel/src/bbdb/lisp/bbdb-mhe hides /sandel/share/emacs/site-lisp/bbdb-mhe
/sandel/src/bbdb/lisp/bbdb-sc hides /sandel/share/emacs/site-lisp/bbdb-sc
/sandel/src/bbdb/lisp/bbdb-com hides /sandel/share/emacs/site-lisp/bbdb-com
/sandel/src/bbdb/lisp/bbdb-site hides /sandel/share/emacs/site-lisp/bbdb-site
/sandel/src/bbdb/lisp/bbdb hides /sandel/share/emacs/site-lisp/bbdb
/sandel/src/bbdb/lisp/bbdb-loaddefs hides /sandel/share/emacs/site-lisp/bbdb-loaddefs
/sandel/src/bbdb/lisp/bbdb-pgp hides /sandel/share/emacs/site-lisp/bbdb-pgp
/sandel/src/bbdb/lisp/bbdb-tex hides /sandel/share/emacs/site-lisp/bbdb-tex
/sandel/src/bbdb/lisp/bbdb-gnus-aux hides /sandel/share/emacs/site-lisp/bbdb-gnus-aux
/sandel/src/bbdb/lisp/bbdb-gnus hides /sandel/share/emacs/site-lisp/bbdb-gnus
/sandel/src/bbdb/lisp/bbdb-anniv hides /sandel/share/emacs/site-lisp/bbdb-anniv
/sandel/src/bbdb/lisp/bbdb-message hides /sandel/share/emacs/site-lisp/bbdb-message
/sandel/src/bbdb/lisp/bbdb-snarf hides /sandel/share/emacs/site-lisp/bbdb-snarf
/sandel/src/bbdb/lisp/bbdb-mua hides /sandel/share/emacs/site-lisp/bbdb-mua
/sandel/src/bbdb/lisp/bbdb-rmail hides /sandel/share/emacs/site-lisp/bbdb-rmail
/sandel/src/bbdb/lisp/bbdb-migrate hides /sandel/share/emacs/site-lisp/bbdb-migrate
/home/mcr/el/csv-mode hides /usr/share/emacs24/site-lisp/emacs-goodies-el/csv-mode
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-xml hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-xml
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-pkg hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-pkg
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-import-latex hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-import-latex
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-latex hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-latex
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-html hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-html
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-blosxom hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-blosxom
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-poem hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-poem
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-journal hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-journal
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-backlink hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-backlink
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-import-xml hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-import-xml
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-mode hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-mode
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-project hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-project
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-regexps hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-regexps
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-latex2png hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-latex2png
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-publish hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-publish
/home/mcr/.emacs.d/elpa/muse-3.20.2/cgi hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/cgi
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-book hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-book
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-xml-common hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-xml-common
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-ikiwiki hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-ikiwiki
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-http hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-http
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-protocols hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-protocols
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-wiki hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-wiki
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-colors hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-colors
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-import-docbook hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-import-docbook
/home/mcr/.emacs.d/elpa/muse-3.20.2/htmlize-hack hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/htmlize-hack
/home/mcr/.emacs.d/elpa/muse-3.20.2/httpd hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/httpd
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-texinfo hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-texinfo
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-docbook hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-docbook
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-context hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-context
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-groff hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-groff
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-ipc hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-ipc
/home/mcr/.emacs.d/elpa/muse-3.20.2/muse-autoloads hides /usr/share/emacs/24.5/site-lisp/elpa/muse-3.20/muse-autoloads
/usr/share/emacs24/site-lisp/cmake-data/cmake-mode hides /usr/share/emacs/site-lisp/cmake-mode
/usr/share/emacs/24.5/site-lisp/debian-startup hides /usr/share/emacs/site-lisp/debian-startup
/home/mcr/el/window hides /usr/share/emacs/24.5/lisp/window
/home/mcr/el/whitespace hides /usr/share/emacs/24.5/lisp/whitespace
/home/mcr/el/tempo hides /usr/share/emacs/24.5/lisp/tempo
/home/mcr/el/pcvs-util hides /usr/share/emacs/24.5/lisp/vc/pcvs-util
/home/mcr/el/log-edit hides /usr/share/emacs/24.5/lisp/vc/log-edit
/home/mcr/el/vc-git hides /usr/share/emacs/24.5/lisp/vc/vc-git
/home/mcr/el/vc-svn hides /usr/share/emacs/24.5/lisp/vc/vc-svn
/home/mcr/el/autoload hides /usr/share/emacs/24.5/lisp/emacs-lisp/autoload
/home/mcr/el/regi hides /usr/share/emacs/24.5/lisp/emacs-lisp/regi

Features:
(shadow sort emacsbug network-stream starttls url-http tls gnutls url-gw
url-auth url-queue url-cache url url-proxy url-privacy url-expand url-methods
url-history url-cookie url-domsuf url-util url-parse auth-source eieio
eieio-core url-vars shr-color color shr browse-url qp mm-archive smiley
mh-mime mh-identity mh-letter mail-extr mule-util mh-thread mh-show goto-addr
thingatpt gnus-cite gnus-art mm-uu mml2015 gnus-sum nnoo gnus-group gnus-undo
nnmail mail-source gnus-start gnus-spec gnus-int message format-spec rfc822
gmm-utils mailheader gnus-win gnus-range gnus gnus-ems nnheader mh-inc
hl-line mh-tool-bar mh-seq byte-opt bytecomp byte-compile cl-extra cconv
minibuffer-complete-cycle mh-xface mh-utils xterm dired-x dired server vcard
mh-folder which-func imenu bbdb-loaddefs bbdb-sc supercite regi bbdb-mhe
mh-comp sendmail mail-utils mh-scan mh-gnus mml mm-view mml-smime mml-sec
smime password-cache dig mailcap mm-decode mm-bodies mm-encode mail-parse
rfc2231 rfc2047 rfc2045 ietf-drums mm-util mail-prsvr gnus-util time-date
mh-e mh-compat mh-acros cl mh-buffers mh-loaddefs bbdb-mua bbdb-com pcase crm
mailabbrev bbdb cl-macs gv bbdb-site timezone package epg-config disp-table
advice help-fns cc-styles cc-align cc-engine cc-vars cc-defs view yaml-mode
muse-blosxom muse-html muse-xml-common cus-edit cus-start cus-load
muse-publish muse-project muse-protocols info easymenu muse-regexps wid-edit
cl-loaddefs cl-lib derived muse muse-nested-tags muse-mode gin-mode rdebug
gud comint ansi-color ring emacs-goodies-el emacs-goodies-custom
emacs-goodies-loaddefs easy-mmode tooltip electric uniquify ediff-hook
vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment lisp-mode prog-mode register page
menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock syntax
facemenu font-core frame cham georgian utf-8-lang misc-lang vietnamese
tibetan thai tai-viet lao korean japanese hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese case-table epa-hook jka-cmpr-hook
help simple abbrev minibuffer nadvice loaddefs button faces cus-face macroexp
files text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote make-network-process
dbusbind gfilenotify dynamic-setting system-font-setting font-render-setting
move-toolbar gtk x-toolkit x multi-tty emacs)

Memory information:
((conses 16 457735 153682)
 (symbols 48 35001 0)
 (miscs 40 17946 642)
 (strings 32 301341 20284)
 (string-bytes 1 5690238)
 (vectors 16 59450)
 (vector-slots 8 1335988 9384)
 (floats 8 453 435)
 (intervals 56 4451 1663)
 (buffers 960 23))

-- 
]               Never tell me the odds!                 | ipv6 mesh networks [
]   Michael Richardson, Sandelman Software Works        |    IoT architect   [
]     [email-masked]  http://www.sandelman.ca/        |   ruby on rails    [